#
# makemoji.pl
#   store emoji->gif image link hash table
#     change #!/usr/bin/perl or so, as you need

{
  package emojiParser;
  use strict;
  use base qw(HTML::Parser);
  my ($tr,$td,$count);
  my ($key,$value);
  
  sub new
  {
    my $class = shift;
    my $self = $class->SUPER::new;
    $self->{emoji} = undef;
    return $self;
  }

  sub start
  {
    my ($self,$tag,$attr) = @_;
    if ($tag eq 'tr'){
      $tr = 1;
      $count = 0;
      undef $key;
      undef $value;
    }
    $td = 1 if ($tag eq 'td');
    if(($tr == 1) && ($tag eq 'img')){
      $value = $$attr{src};
      $value =~ s/\s+//g;
    }
  }

  sub text
  {
    my ($self,$text) = @_;
    if (($tr == 1) && ($td == 1) && ($count == 2)){ 
      $key = $text;
      $key =~ s/\s+//g;
    }
    $count++ if($text !~ m/^\s+$/);
  }

  sub end
  {
    my ($self,$tag,$orig) = @_;
    $tr = 0 if ($tag eq 'tr');
    $td = 0 if ($tag eq 'td');
    if(($tag eq 'tr') && (defined $key) && (defined $value)){
      $self->{emoji}{$key} = $value;
    }
  }
}

#
# main
#
use LWP::UserAgent;
use URI::URL;
use IO::Select;
use IO::Socket;
use strict;
use Storable;

my ($emoji,$ua,$res,$p,$base);
my ($url,$f);
my %table;
my $file = 'emoji';

$emoji = "http://www.nttdocomo.co.jp/i/tag/emoji/index.html";
$ua  = new LWP::UserAgent;
$p = emojiParser->new;
# $ua->proxy('http','http://www.hoge.co.jp:8080');
$res = $ua->request(HTTP::Request->new(GET => $emoji));
if($res->is_success){
  $base = $res->base;
  $p->parse($res->content);
  for (keys %{$p->{emoji}}){
    $url = sprintf("%s",url($p->{emoji}{$_},$base)->abs);
    $table{$_} = $url;
  }
}else{
  print $p->error_as_HTML;
  exit;
}
store \%table,$file;
__DATA__

=head1 

makemoji.pl i[hŎgpĂGƑΉGIFC[W
  ̃NnbVƂăt@Cɕۑ

=head1 Tv

improxy.plgpGGIFC[Wւ̃Nւ̃nbV
쐬t@Cɕۑ܂B̑ΉNTT DoCoMoЂ񋟂
Gꗗ
('http://www.nttdocomo.co.jp/i/tag/emoji/index.html')
HTML̂̃e[uoĂ܂B̂
̃y[WɕύXꍇɂ͂̃XNvgɂύXKv
łB

=head1 o[W

̃vO makemoji.pl ver.1.0łB

=head1 

Copyright (c) 2000, \ (keiichi@tokyo.pm.org)
Permission is hereby granted to distribute this document
intact with the Perl distribution, and in accordance with
the licenses of the Perl distribution; derived documents
must include this copyright notice intact.

=cut
